/**
 ** Original Code
 ** Copyright (c) 1998 Reid Barton, Dan Adkins, Harald Prokop,
 ** Copyright (c) 1998 Matteo Frigo, Chris Joerg, Martin Rinard,
 ** Copyright (c) 1998 Don Dailey, Charles E. Leiserson

 ** Permission is hereby granted, free of charge, to any person
 ** obtaining a copy of this software and associated documentation
 ** files (the "Software"), to deal in the Software without
 ** restriction, including without limitation the rights to use,
 ** copy, modify, merge, publish, distribute, sublicense, and/or sell
 ** copies of the Software, and to permit persons to whom the
 ** Software is furnished to do so, subject to the following
 ** conditions:

 ** The above copyright notice and this permission notice shall be
 ** included in all copies or substantial portions of the Software.

 ** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 ** EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 ** OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 ** NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 ** HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 ** WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 ** FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 ** OTHER DEALINGS IN THE SOFTWARE.

 ** 

 ** Port to Cilk++
 ** Copyright (c) 2010 Ruben Perez, Gregory Malecha

 ** Permission is hereby granted, free of charge, to any person
 ** obtaining a copy of this software and associated documentation
 ** files (the "Software"), to deal in the Software without
 ** restriction, including without limitation the rights to use,
 ** copy, modify, merge, publish, distribute, sublicense, and/or sell
 ** copies of the Software, and to permit persons to whom the
 ** Software is furnished to do so, subject to the following
 ** conditions:

 ** The above copyright notice and this permission notice shall be
 ** included in all copies or substantial portions of the Software.

 ** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 ** EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 ** OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 ** NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 ** HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 ** WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 ** FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 ** OTHER DEALINGS IN THE SOFTWARE.
 **/
/* Poll upward */
class Abort {
  Abort *parent;
  bool aborted;

 public:
  Abort() : aborted(false), parent(NULL) { }

  explicit Abort(Abort* p) : aborted(false), parent(p) { }

  int isAborted() const {
#ifdef STATS
      poll_count() += 1;
#endif    
#ifdef POLL_UP_CACHE
    if (this->aborted) return 1;
    if (this->parent && this->parent->isAborted())
      const_cast<Abort*>(this)->aborted = true;
    return this->aborted;
#else
    return this->aborted || (this->parent && this->parent->isAborted());
#endif
  }

  inline void abort() {
#ifdef STATS
      if(!this->aborted){
          abort_count() += 1;
      }
#endif
    this->aborted = true;
  }
};
